--ISHOD 4

/* I4Z1 Za kupca Kim Abercrombie kreirajte ra?un s datumom 06. srpnja 2023., s proizvoljnim brojem ra?una,
za kupnju 2 proizvoda "LL Road Rear Wheel 826", s cijenom po komadu 200 EUR, popustom 30% i
ukupnom cijenom 280 EUR. */

insert into Racun(DatumIzdavanja, BrojRacuna, KupacID)
values ('2023-06-06', 'SO76234', 3)

insert into Stavka(RacunID, ProizvodID, Kolicina, CijenaPoKomadu, UkupnaCijena, PopustUPostocima)
values (44189, 826, 2, 200, 280, 30)
/*I4Z2 Crnim proizvodima pove?ajte cijenu za 20 eura i promijenite im podatak BrojProizvoda na na?in da
postoje?em broju proizvoda dodate nastavak '-plus'. Obavezno rijeite jednim upitom. */

update Proizvod 
set CijenaBezPDV += 20, BrojProizvoda += '-plus'
where Boja like 'Crna'

/*I4Z3 Izbriite prvu stavku ra?una s najmanjim ID-em u bazi. */

delete Stavka
from Stavka as s
where RacunID = 43659 and IDStavka = 1

/*I4Z4 Ispiite proizvode s minimalnom koli?inom na skladitu manjom od 100. Proizvode poredajte po boji
padaju?e, ali tako da za istu boju idu od ve?ih prema manjim vrijednostima podatka CijenaBezPDV. */

select p.naziv, p.MinimalnaKolicinaNaSkladistu, p.Boja, p.CijenaBezPDV
from Proizvod as p
where p.MinimalnaKolicinaNaSkladistu < 100
group by p.MinimalnaKolicinaNaSkladistu, p.Naziv, p.Boja, p.CijenaBezPDV
order by p.Boja desc, p.CijenaBezPDV desc

/* I4Z5 Obriite sve podatke o kupcu imena John Berger (njegove podatke, njegove ra?une i pripadne stavke
ra?una). Pazite na redoslijed izvravanja upita. Ukoliko je to u bazi ve? u?injeno, svejedno napiite upite
kojima biste to napravili. */

delete Stavka
from Stavka as s
inner join Racun as r
on s.RacunID = r.IDRacun
where r.KupacID = 88

delete Racun
from Racun as r
where r.KupacID = 88

delete Kupac
from Kupac as k
where k.Ime = 'John' and k.Prezime = 'Berger'

/* I4Z6 Koriste?i unutarnja spajanja, ispiite sve ra?une koji su pla?eni karticom Diners ili MasterCard.
Obavezno rijeite jednim upitom. */

select r.IDRacun, kk.Tip
from Racun as r
inner join KreditnaKartica as kk
on r.KreditnaKarticaID = kk.IDKreditnaKartica
where kk.Tip = 'Diners' or kk.tip = 'MasterCard'
order by kk.Tip

/*I4Z7 Koriste?i desno vanjsko spajanje ispiite sve brojeve ra?una i uz svaki broj ra?una ispiite ime i prezime
kupca kojem je izdan ra?un. Prikaite i kupce koje nemaju ra?une. Rezultat sortirajte rastu?e po broju
ra?una.*/

select r.BrojRacuna, k.Ime + ' ' + k.Prezime
from Racun as r
right outer join Kupac as k
on r.KupacID = k.IDKupac
order by r.BrojRacuna asc

/*I4Z8 Svim ra?unima koji nemaju komercijalista i kreditnu karticu izbriite komentar. Obavezno to napravite
jednim upitom. Ukoliko je to u bazi ve? u?injeno, svejedno napiite upit kojim biste to napravili. */

delete r.Komentar
from Racun as r
where r.KomercijalistID is null and r.KreditnaKarticaID is null

/*I4I9 Koriste?i puno vanjsko spajanje, ispiite samo proizvode koji nemaju dodijeljenu niti jednu potkategoriju i
potkategorije koji nisu pridruene niti jednom proizvodu. Obavezno rijeite jednim upitom. Ako u bazi
nema takvih proizvoda/potkategorija, za potrebe provjere rada upita upiite po jedan redak u
odgovaraju?e tablice. */

select p.Naziv as 'Proizvod', pk.Naziv as 'Potkategorija'
from Proizvod as p
full outer join Potkategorija as pk
on p.PotkategorijaID = pk.IDPotkategorija
where p.PotkategorijaID is null

/*I4Z10 Ispiite popis brojeva ra?una (podatak BrojRacuna iz tablice Racun) s nazivima pripadaju?ih proizvoda
na pojedinom ra?unu, cijenom po komadu i brojevima kreditnih kartica (podatak Broj iz tablice
KreditnaKartica) s kojima su ra?uni pla?eni. Moraju biti vidljivi i ra?uni koji nisu pla?eni kreditnim
karticama. Obavezno to napravite jednim upitom i rezultat sortirajte padaju?e po podatku BrojProizvoda
iz tablice Proizvod. */

select r.BrojRacuna, p.Naziv, s.CijenaPoKomadu, kk.Broj
from Racun as r
inner join Stavka as s
on r.IDRacun = s.RacunID
inner join Proizvod as p
on s.ProizvodID = p.IDProizvod
inner join KreditnaKartica as kk
on r.KreditnaKarticaID = kk.IDKreditnaKartica 
order by  p.BrojProizvoda desc

--ISHOD 5

/*I5Z1 Ispiite jedinstvenu listu imena i prezimena kupaca kojima je ukupni iznos pripadaju?ih ra?una (suma
ukupne cijene stavaka) ve?i od 1500 eura, za ra?une izdane u 2001. godini. */

select distinct k.Ime + ' ' + k.Prezime, SUM(s.UkupnaCijena), YEAR(r.DatumIzdavanja)
from Kupac as k
inner join Racun as r
on k.IDKupac = r.KupacID
inner join Stavka as s
on r.IDRacun = s.RacunID
group by k.Ime + ' ' + k.Prezime, YEAR(r.DatumIzdavanja)
having SUM(s.UkupnaCijena) > 1500 and YEAR(r.DatumIzdavanja) = 2001

/*I5Z2 Ispiite koliko je izdanih ra?una te prvi izdani ra?un (min datuma izdavanja), prikazano po imenu i
prezimenu komercijalista, ali uzimaju?i u obzir samo ra?une izdane 2001. godine. */

select COUNT(r.IDRacun) as 'Koliko izdanih', MIN(r.DatumIzdavanja) as 'Prvi izdani racun', k.Ime + ' ' + k.Prezime
from Racun as r
inner join Komercijalist as k
on r.KomercijalistID = k.IDKomercijalist
where YEAR(r.DatumIzdavanja) = 2001
group by k.Ime, k.prezime

/*I5Z3 Ispiite u prvom stupcu godinu, u drugom stupcu mjesec, a u tre?em stupcu dan izdavanja prvog
ra?una. */

select top 1 YEAR(r.DatumIzdavanja), MONTH(r.DatumIzdavanja), DAY(r.DatumIzdavanja), r.BrojRacuna
from Racun as r

/*I5Z4 Ispiite ime i modificirano prezime svih kupaca ?ije prezime po?inje na A i zavrava na g. Modificirajte
prezime tako da prezimena koja sadre 'ong' zamijene 'ong' s 'und'  npr. za prezime 'Achong
modificirano prezime treba izgledati ovako: 'Achund'. */

select k.Ime + ' ' + k.Prezime
from Kupac as k
where k.prezime like 'A%g'

update Kupac
set Prezime = Prezime + '%und'
where Prezime like '%und'

--ISHOD 6
/*I6Z1 Ispiite drave koje imaju iznadprosje?an broj gradova. Zadatak rijeiti primjenom podupita u FROM
dijelu. */

select d.Naziv
from (
	select *
	from Drzava as d
	) as d
inner join Grad as g
on  d.IDDrzava = g.DrzavaID
group by d.naziv
having Count(g.DrzavaID) > AVG(g.DrzavaID)

	
/*I6Z2 Ispiite imena i prezimena (bez ponavljanja) komercijalista koji su prodali proizvode ?ija CijenaBezPDV
je ve?a od 3000. Zadatak treba rijeiti isklju?ivo podupitima, bez spajanja. */

/*I6Z3 Za sve ra?une ispiite broj ra?una i najve?u koli?inu po stavci pojedinog ra?una (maksimalna vrijednost
Koli?ina iz tablice Stavka za pojedini ra?un). */

select r.BrojRacuna, (
	select MAX(s.Kolicina)
	from Stavka as s
	where r.IDRacun = s.RacunID) as Najev?aKolicina
from Racun as r

/*I6Z4 Ispiite listu koja prikazuje popis naziva proizvoda bez ponavljanja i ukupnu zaradu po proizvodu (suma
UkupnaCijena iz tablice Stavka). Rezultat sortirajte padaju?e po vrijednosti podatka BrojProizvoda. */

select distinct p.naziv, p.BrojProizvoda, (
	select SUM(s.UkupnaCijena)
	from Stavka as s
	where p.IDProizvod = s.ProizvodID) as UkupnaZarada
from Proizvod as p
order by p.BrojProizvoda desc
